package com.cirmuller.maidaddition.entity.behaviour;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask;
import com.cirmuller.maidaddition.entity.memory.CraftingAndCarryingMemory;
import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.cirmuller.maidaddition.threads.CalculateCraftingStackThread;
import com.github.tartaricacid.touhoulittlemaid.entity.chatbubble.IChatBubbleData;
import com.github.tartaricacid.touhoulittlemaid.entity.chatbubble.implement.TextChatBubbleData;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import java.util.Map;
import net.minecraft.core.Vec3i;
import net.minecraft.network.chat.Component;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.ai.behavior.Behavior;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraft.world.entity.ai.memory.WalkTarget;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.wrapper.RangedWrapper;
import studio.fantasyit.maid_storage_manager.storage.ItemHandler.SimulateTargetInteractHelper;

public class CraftingAndCarryingBehaviour extends Behavior<EntityMaid> {
  private final float speedModifier = 0.8F;
  
  private final Component lackOfSpace = (Component)Component.m_237115_("maidaddition.lack_of_space");
  
  private final Component lackOfMaterial = (Component)Component.m_237115_("maidaddition.lack_of_material");
  
  private final Component donotMoveChest = (Component)Component.m_237115_("maidaddition.donot_move_chest");
  
  public CraftingAndCarryingBehaviour() {
    super(Map.of((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get(), MemoryStatus.REGISTERED));
  }
  
  protected void start(ServerLevel pLevel, EntityMaid maid, long pGameTime) {
    CraftingAndCarryingMemory memory = maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get()).orElse(null);
    assert memory != null;
    memory.start();
  }
  
  protected void tick(ServerLevel pLevel, EntityMaid maid, long pGameTime) {
    CraftingAndCarryingMemory memory = maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get()).orElse(null);
    assert memory != null;
    if (!memory.isCalculated())
      return; 
    if (memory.isBackPackFull()) {
      if (memory.walkTarget == null && !memory.getChestsFrom().isEmpty())
        memory.walkTarget = memory.getChestsFrom().get(0); 
      unloadedBackPack(pLevel, maid, pGameTime);
      return;
    } 
  }
  
  private void doCurrentTask(ServerLevel level, EntityMaid maid, long gameTime) {
    CraftingAndCarryingMemory memory = maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get()).orElse(null);
    assert memory != null;
    CraftingTask currentTask = memory.getCraftingTasks().peek();
    switch (null.$SwitchMap$com$cirmuller$maidaddition$Utils$CraftingTasks$CraftingTask$CraftingState[currentTask.getState().ordinal()]) {
      case 1:
        if (memory.walkTarget == null) {
          CalculateCraftingStackThread.ChestPos chestPos = CalculateCraftingStackThread.ChestPos.findItemInChests(level, memory.getChestsFrom(), currentTask.getItemToTakeOut().m_41720_());
          if (chestPos == null) {
            maid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(this.lackOfMaterial));
            memory.pop();
            return;
          } 
          memory.setChestPos(chestPos);
        } 
        maid.m_6274_().m_21879_(MemoryModuleType.f_26370_, new WalkTarget(memory.walkTarget, 0.8F, 0));
        if (maid.m_20097_().m_123314_((Vec3i)memory.walkTarget, 2.0D)) {
          if (!memory.isOpeningChest()) {
            int tickDelay = memory.getOpenChestTickDelay();
            if (tickDelay == 0) {
              (new SimulateTargetInteractHelper(maid, memory.walkTarget, null, level)).open();
              break;
            } 
            if (tickDelay == 100)
              memory.setIsOpeningChest(true); 
            break;
          } 
          BlockEntity chestEntity = level.m_7702_(memory.walkTarget);
          if (chestEntity == null) {
            memory.walkTarget = null;
            memory.chestPos = null;
            maid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(this.donotMoveChest));
            return;
          } 
          LazyOptional<IItemHandler> capability = chestEntity.getCapability(ForgeCapabilities.ITEM_HANDLER);
          if (!capability.isPresent()) {
            memory.walkTarget = null;
            memory.chestPos = null;
            maid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(this.donotMoveChest));
            return;
          } 
          capability.ifPresent(cap -> {
                if ((memory.getChestPos()).index < cap.getSlots()) {
                  ItemStack stackInChest = cap.extractItem(memory.chestPos.index, currentTask.getItemToTakeOut().m_41613_(), false);
                  ItemStack remain = insertItemToBackpack((IItemHandler)maid.getAvailableBackpackInv(), stackInChest);
                  if (remain.m_41619_()) {
                    if (stackInChest.m_41613_() == currentTask.getItemToTakeOut().m_41613_()) {
                      memory.pop();
                      memory.walkTarget = null;
                      memory.chestPos = null;
                    } else {
                      memory.walkTarget = null;
                      memory.chestPos = null;
                      currentTask.getItemToTakeOut().m_41764_(currentTask.getItemToTakeOut().m_41613_() - stackInChest.m_41613_());
                    } 
                  } else {
                    cap.insertItem(memory.chestPos.index, remain, false);
                    while (((CraftingTask)memory.getCraftingTasks().peek()).getState() != CraftingTask.CraftingState.Crafting)
                      memory.getCraftingTasks().pop(); 
                    memory.setIsBackpackFull(true);
                    memory.walkTarget = null;
                    memory.chestPos = null;
                  } 
                } else {
                  memory.walkTarget = null;
                  memory.chestPos = null;
                  maid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(this.donotMoveChest));
                } 
              });
        } 
        break;
    } 
  }
  
  private ItemStack insertItemToBackpack(IItemHandler backpack, ItemStack stack) {
    ItemStack remain = stack;
    for (int i = 0; i < backpack.getSlots(); i++) {
      remain = backpack.insertItem(i, remain, false);
      if (remain.m_41619_())
        return ItemStack.f_41583_; 
    } 
    return remain;
  }
  
  private void unloadedBackPack(ServerLevel pLevel, EntityMaid maid, long pGameTime) {
    CraftingAndCarryingMemory memory = maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get()).orElse(null);
    assert memory != null;
    BlockEntity entity = pLevel.m_7702_(memory.walkTarget);
    if (entity == null || !entity.getCapability(ForgeCapabilities.ITEM_HANDLER).isPresent()) {
      int index = memory.getChestsFrom().indexOf(memory.walkTarget);
      if (index + 1 < memory.getChestsFrom().size()) {
        memory.walkTarget = memory.getChestsFrom().get(index + 1);
      } else {
        memory.walkTarget = null;
        maid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(this.lackOfSpace));
      } 
      return;
    } 
    maid.m_6274_().m_21879_(MemoryModuleType.f_26370_, new WalkTarget(memory.walkTarget, 0.8F, 0));
    if (maid.m_20097_().m_123314_((Vec3i)memory.walkTarget, 2.0D))
      if (memory.isOpeningChest()) {
        RangedWrapper maidBackPack = maid.getAvailableBackpackInv();
        BlockEntity chest = pLevel.m_7702_(memory.walkTarget);
        assert chest != null;
        LazyOptional<IItemHandler> capability = chest.getCapability(ForgeCapabilities.ITEM_HANDLER);
        capability.ifPresent(cap -> {
              boolean isBackPackEmpty = removeItem(cap, maidBackPack);
              if (isBackPackEmpty) {
                memory.setIsBackpackFull(false);
                memory.setIsOpeningChest(false);
                SimulateTargetInteractHelper helper = new SimulateTargetInteractHelper(maid, memory.walkTarget, null, pLevel);
                helper.stop();
                memory.walkTarget = null;
              } else {
                memory.setIsOpeningChest(false);
                int indexOfCurrentChest = memory.getChestsFrom().indexOf(memory.walkTarget);
                SimulateTargetInteractHelper helper = new SimulateTargetInteractHelper(maid, memory.walkTarget, null, pLevel);
                helper.stop();
                if (indexOfCurrentChest + 1 < memory.getChestsFrom().size()) {
                  memory.walkTarget = memory.getChestsFrom().get(indexOfCurrentChest + 1);
                } else {
                  memory.walkTarget = null;
                  maid.getChatBubbleManager().addChatBubble((IChatBubbleData)TextChatBubbleData.type2(this.lackOfSpace));
                } 
              } 
            });
      } else {
        int tickDelay = memory.getOpenChestTickDelay();
        if (tickDelay == 0) {
          SimulateTargetInteractHelper helper = new SimulateTargetInteractHelper(maid, memory.walkTarget, null, pLevel);
          helper.open();
        } else if (tickDelay == 100) {
          memory.setIsOpeningChest(true);
        } 
      }  
  }
  
  protected boolean removeItem(IItemHandler chest, RangedWrapper maidBackpack) {
    boolean result = true;
    for (int i = 0; i < maidBackpack.getSlots(); i++) {
      ItemStack remainItemStack = maidBackpack.extractItem(i, 64, false);
      for (int j = 0; j < chest.getSlots() && !remainItemStack.m_41619_(); j++)
        remainItemStack = chest.insertItem(j, remainItemStack, false); 
      if (!remainItemStack.m_41619_()) {
        result = false;
        maidBackpack.insertItem(i, remainItemStack, false);
      } 
    } 
    return result;
  }
  
  protected void stop(ServerLevel pLevel, EntityMaid pEntity, long pGameTime) {}
  
  protected boolean canStillUse(ServerLevel pLevel, EntityMaid pEntity, long pGameTime) {
    return true;
  }
  
  protected boolean m_7773_(long pGameTime) {
    return false;
  }
  
  protected boolean checkExtraStartConditions(ServerLevel pLevel, EntityMaid pOwner) {
    CraftingAndCarryingMemory memory = pOwner.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get()).orElse(null);
    return (memory != null && memory.isInitialized());
  }
}
